/**
 * JoX⏕NXłB
 */
public class MyCanvas {
	/**
	 * JoXB
	 */
	public static final CharacterCanvas c = new CharacterCanvas();
	
	/**
	 * vCx[gȃRXgN^B
	 */
	private MyCanvas() {
		; // Ȃ
	}
}

/**
 * LN^[JoXNXłB
 */
class CharacterCanvas {
	/**
	 * B
	 */
	private int width;
	/**
	 * B
	 */
	private int height;
	/**
	 * wiB
	 */
	private char background;
	/**
	 * JoXB
	 */
	private char[][] canvas;
	
	/**
	 * RXgN^B
	 */
	public CharacterCanvas() {
		this(20, 20);
	}
	
	/**
	 * RXgN^B
	 * @param width 
	 * @param height 
	 */
	public CharacterCanvas(int width, int height) {
		this(width, height, '.');
	}
	
	/**
	 * RXgN^B
	 * @param width 
	 * @param height 
	 * @param background wiF
	 */
	public CharacterCanvas(int width, int height, char background) {
		this.initialize(width, height, background);
	}
	
	/**
	 * JoX܂B
	 */
	public void initialize() {
		this.initialize(this.width, this.height, this.background);
	}
	
	/**
	 * JoX܂B
	 * @param width 
	 * @param height 
	 * @param background wi
	 */
	public void initialize(int width, int height, char background) {
		this.width = width;
		this.height = height;
		this.background = background;
		
		// JoX̏
		this.canvas = new char[height][width];
		for(int j = 0; j < this.canvas.length; j ++) {
			for(int i = 0; i < this.canvas[j].length; i ++) {
				this.canvas[j][i] = background;
			}
		}
	}
	
	/**
	 * JoX\܂B
	 */
	public void print() {
		for(int j = 0; j < height; j ++) {
			for(int i = 0; i < width; i ++) {
				System.out.print(this.canvas[j][i]);
			}
			System.out.println();
		}
	}
	
	/**
	 * wiԂ܂B
	 * @return wi
	 */
	public char getBackgroundChar() {
		return this.background;
	}
	
	/**
	 * wiݒ肵܂B
	 * @param background wi
	 */
	public void setBackgroundChar(char background) {
		this.background = background;
	}
	
	/**
	 * wʒuɕ`悵܂B
	 * JoX͈͊ÔƂɂ͉܂B
	 * @param x XW
	 * @param y YW
	 * @param c 
	 */
	public void drawPoint(int x, int y, char c) {
		try {
			this.canvas[y][x] = c;
		} catch(ArrayIndexOutOfBoundsException e) {
			; // Ȃ
		}
	}
	
	/**
	 * lp``悵܂B
	 * @param x1 N_ XW
	 * @param y1 N_ YW
	 * @param x2 I_ XW
	 * @param y2 I_ YW
	 * @param c 
	 */
	public void drawRect(int x1, int y1, int x2, int y2, char c) {
		for(int i = Math.min(x1, x2); i <= Math.max(x1, x2); i ++) {
			this.drawPoint(i, y1, c);
			this.drawPoint(i, y2, c);
		}
		for(int j = Math.min(y1, y2); j <= Math.max(y1, y2); j ++) {
			this.drawPoint(x1, j, c);
			this.drawPoint(x2, j, c);
		}
	}
	
	/**
	 * lp``悵A̒ghԂ܂B
	 * @param x1 N_ XW
	 * @param y1 N_ YW
	 * @param x2 I_ XW
	 * @param y2 I_ YW
	 * @param c 
	 */
	public void drawRectFill(int x1, int y1, int x2, int y2, char c) {
		for(int j = Math.min(y1, y2); j <= Math.max(y1, y2); j ++) {
			for(int i = Math.min(x1, x2); i <= Math.max(x1, x2); i ++) {
				this.drawPoint(i, j, c);
			}
		}
	}
	
	/**
	 * `悵܂B
	 * @param x1 N_ XW
	 * @param y1 N_ YW
	 * @param x2 I_ XW
	 * @param y2 I_ YW
	 * @param c 
	 */
	public void drawLine(int x1, int y1, int x2, int y2, char c) {
		this.drawLine((double)x1, (double)y1, (double)x2, (double)y2, c);
	}
	
	/**
	 * `悷邽߂̓\bhłBċA֐gpĂ܂B
	 * ċA֐̗߂ɁÂ悤ȎƂ܂BASY̎͗ǂȂłB
	 * @param x1 N_ XW
	 * @param y1 N_ YW
	 * @param x2 I_ XW
	 * @param y2 I_ YW
	 * @param c 
	 */
	private void drawLine(double x1, double y1, double x2, double y2, char c) {
		this.drawPoint((int)x1, (int)y1, c);
		this.drawPoint((int)x2, (int)y2, c);
		
		if(Math.abs(x2 - x1) < 1.0 && Math.abs(y2 - y1) < 1.0) {
			; // Ȃ
		} else {
			double x3 = (x1 + x2) / 2.0;
			double y3 = (y1 + y2) / 2.0;
			
			// ċAĂяo(2)
			this.drawLine(x1, y1, x3, y3, c);
			this.drawLine(x3, y3, x2, y2, c);
		}
	}
	
	/**
	 * w蕶œhԂ܂BJoXOw肵ꍇ͉܂B
	 * @param x XW
	 * @param y YW
	 * @param c 
	 */
	public void fill(int x, int y, char c) {
		if(c == this.canvas[y][x]) {
			; // wW̕ƕ`敶ꍇ͉Ȃ
		} else {
			try {
				this.fill(x, y, c, this.canvas[y][x]);
			} catch(ArrayIndexOutOfBoundsException e) {
				; //@Ȃ
			}
		}
	}
	
	/**
	 * w蕶œhԂ߂̓\bhłBċA֐gpĂ܂B
	 * @param x XW
	 * @param y YW
	 * @param toChar u̕
	 * @param fromChar uO̕
	 */
	private void fill(int x, int y, char toChar, char fromChar) {
		this.drawPoint(x, y, toChar);
		
		// ċAĂяo(4)
		if(x > 0 && this.canvas[y][x - 1] == fromChar) {
			this.fill(x - 1, y, toChar, fromChar);
		}
		if(x < this.width - 1 && this.canvas[y][x + 1] == fromChar) {
			this.fill(x + 1, y, toChar, fromChar);
		}
		if(y > 0 && this.canvas[y - 1][x] == fromChar) {
			this.fill(x, y - 1, toChar, fromChar);
		}
		if(y < this.height - 1 && this.canvas[y + 1][x] == fromChar) {
			this.fill(x, y + 1, toChar, fromChar);
		}
	}
}